import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _extends from 'babel-runtime/helpers/extends';
import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

var _class, _class2, _temp2;

//外部依赖包
import React from 'react';
import PropTypes from 'prop-types';
import merge from 'lodash/merge';

import defaultRulesDecorator from '../decorator/defaultRules';
import validateDecorator from '../decorator/validate';
import commonContextDecorator from '../decorator/commonContext';
// import pureRenderWithLodashDecorator from '../decorator/pureRenderWithLodash';

//防止被重复渲染
// @pureRenderWithLodashDecorator
//验证name等值是否定义

/**
 * 如果覆盖了render则，用不到componentType、currentAntdComponent、getSepcialRuleByType、getDefaultRules
 */
var BasicComponent = validateDecorator(_class = defaultRulesDecorator(_class = commonContextDecorator(_class = (_temp2 = _class2 = function (_React$Component) {
  _inherits(BasicComponent, _React$Component);

  function BasicComponent() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, BasicComponent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = BasicComponent.__proto__ || _Object$getPrototypeOf(BasicComponent)).call.apply(_ref, [this].concat(args))), _this), _this.componentType = 'text', _this.currentAntdComponent = undefined, _this.localeKey = undefined, _temp), _possibleConstructorReturn(_this, _ret);
  }
  //这里把所有基础表单组件的propTypes都定义了

  //定义组件类型，如果组件props.type没有设置，则用组件默认设置的
  //继承此类，看情况覆盖这个属性

  //定义当前需要用到的antd表单组件

  //当前组件的locale对象，如input的是afcInput


  _createClass(BasicComponent, [{
    key: 'getSepcialRuleByType',

    //设置特殊的async-validator rules
    value: function getSepcialRuleByType() {
      return [];
    }
  }, {
    key: 'renderFormItem',
    value: function renderFormItem(item, otherProps) {
      var FormItem = this.context.FormItem;

      var _props = this.props,
          name = _props.name,
          value = _props.value,
          _props$rules = _props.rules,
          rules = _props$rules === undefined ? [] : _props$rules,
          other = _objectWithoutProperties(_props, ['name', 'value', 'rules']);

      var specialRules = this.getSepcialRuleByType(other.type);
      if (other.type === 'email' || other.type === 'url') {
        other.type = 'text';
      }
      if (!other.type && this.componentType) {
        //处理checkbox等
        other.type = this.componentType;
      }
      return React.createElement(
        FormItem,
        _extends({}, other, {
          name: name,
          initialValue: value,
          rules: [].concat(_toConsumableArray(this.getDefaultRules(other.type, this.locale, other.label ? other.label : name)), _toConsumableArray(specialRules), _toConsumableArray(rules))
        }, otherProps),
        item
      );
    }
  }, {
    key: 'validateRender',
    value: function validateRender(component) {
      if (!this.currentAntdComponent) {
        console.error('继承BasicComponent，必须定义currentAntdComponent');
      }
      //如果没有使用Form.create()
      if (!this.context.form) {
        return component;
      }
      return this.renderFormItem(component);
    }
  }, {
    key: 'render',
    value: function render() {
      var component = React.createElement(
        this.currentAntdComponent,
        null,
        this.props.children
      );
      return this.validateRender(component);
    }
  }, {
    key: 'locale',
    get: function get() {
      if (!this._tempLocale) {
        var currentComponentLocale = {};
        if (this.localeKey) {
          currentComponentLocale = _defineProperty({}, this.localeKey, this.props.locale || {});
        }
        //context.locale是getter
        this._tempLocale = merge(this.context.locale || {}, currentComponentLocale);
      }
      return this._tempLocale;
    }
  }]);

  return BasicComponent;
}(React.Component), _class2.displayName = 'AntdFormComponent', _class2.propTypes = {
  name: PropTypes.string,
  label: PropTypes.string,
  type: PropTypes.string,
  rules: PropTypes.array,
  //input
  min: PropTypes.number,
  //input
  max: PropTypes.number,
  //input
  onlyLetter: PropTypes.bool,
  //password（passord继承input）
  onlyLetterAndNumber: PropTypes.bool,
  //password
  checkPassword: PropTypes.bool
}, _temp2)) || _class) || _class) || _class;

export { BasicComponent as default };