import _Object$assign from 'babel-runtime/core-js/object/assign';
import _Promise from 'babel-runtime/core-js/promise';
import _extends from 'babel-runtime/helpers/extends';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

var _class, _temp, _class5, _temp7;

//外部依赖包
import React from 'react';
import PropTypes from 'prop-types';
import isFunction from 'lodash/isFunction';
import AForm from 'antd/lib/form';
import merge from 'lodash/merge';
//内部依赖包
import event from '../../utils/event';
import { validateField as _validateField, toUpperCaseByPosition, findAllReactComponentsByType } from '../../utils/util';
import defaultLoacale from '../../locale-provider/zh_CN';
import BasicComponent from '../basic-component';

var Form = (_temp = _class = function (_React$Component) {
  _inherits(Form, _React$Component);

  function Form() {
    _classCallCheck(this, Form);

    return _possibleConstructorReturn(this, (Form.__proto__ || _Object$getPrototypeOf(Form)).apply(this, arguments));
  }

  _createClass(Form, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        size: this.props.size,
        hasFeedback: this.props.hasFeedback,
        labelCol: this.props.labelCol,
        wrapperCol: this.props.wrapperCol,
        locale: this.locale,
        trigger: this.props.trigger,
        useForm: true
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var other = _objectWithoutProperties(this.props, []);
      //为了防止传递给原生form，react会报错。


      delete other.locale;
      delete other.hasFeedback;
      delete other.labelCol;
      delete other.wrapperCol;
      delete other.size;
      return React.createElement(
        AForm,
        other,
        this.props.children
      );
    }
  }, {
    key: 'locale',
    get: function get() {
      return merge(defaultLoacale, this.context.antLocale, this.props.locale);
    }
  }], [{
    key: 'create',
    value: function create() {
      var _class2, _temp3;

      var Decorator = (_temp3 = _class2 = function (_React$Component2) {
        _inherits(Decorator, _React$Component2);

        function Decorator() {
          var _ref;

          var _temp2, _this2, _ret;

          _classCallCheck(this, Decorator);

          for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          return _ret = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref = Decorator.__proto__ || _Object$getPrototypeOf(Decorator)).call.apply(_ref, [this].concat(args))), _this2), _this2.formItem = getFormItemComponent(_this2), _this2.form = {
            //存放temp
            customComponent: {},
            getFieldDecorator: function getFieldDecorator(name, props) {
              var _this3 = this;

              return function (component) {
                function newComponent(props) {
                  return React.cloneElement(component, props);
                }
                if (!_this3.customComponent[name]) {
                  //不可以重新定义，要不组件在state改变的情况下也会unmount
                  _this3.customComponent[name] = function (_BasicComponent) {
                    _inherits(Component, _BasicComponent);

                    function Component() {
                      var _ref2;

                      var _temp4, _this4, _ret2;

                      _classCallCheck(this, Component);

                      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
                        args[_key2] = arguments[_key2];
                      }

                      return _ret2 = (_temp4 = (_this4 = _possibleConstructorReturn(this, (_ref2 = Component.__proto__ || _Object$getPrototypeOf(Component)).call.apply(_ref2, [this].concat(args))), _this4), _this4.currentAntdComponent = newComponent, _temp4), _possibleConstructorReturn(_this4, _ret2);
                    }

                    return Component;
                  }(BasicComponent);
                }
                var AntdFormComponent = _this3.customComponent[name];
                return React.createElement(AntdFormComponent, _extends({}, props, {
                  name: name,
                  value: props.initialValue
                }));
              };
            },

            /**
             * 获取一组输入控件的 Error ，如不传入参数，则获取全部组件的 Error
             * @param  {array} names name数组
             * @return {object} 返回指定fieldsError或者全部fieldsError
             */
            getFieldsError: function getFieldsError(names) {
              if (!names) {
                return _this2.fieldsError;
              } else if (names[0]) {
                var fieldsError = {};
                name.forEach(function (v) {
                  if (_this2.fieldsError[v] !== undefined) {
                    fieldsError[v] = _this2.fieldsError[v];
                  }
                });
              }
            },
            /**
             * 获取某个输入表单控件的 Error
             * @param  {string} name 表单空间name值
             * @return {object} 返回指定fieldsError
             */
            getFieldError: function getFieldError(name) {
              return _this2.fieldsError[name];
            },
            /**
             * 获取一组输入控件的值，如不传入参数，则获取全部组件的值
             * @param  {array} names name数组
             * @return {object} 返回指定fieldsValue或者全部fieldsValue
             */
            getFieldsValue: function getFieldsValue(names) {
              if (!names) {
                return _this2.fieldsValue;
              } else if (names[0]) {
                var fieldsValue = {};
                name.forEach(function (v) {
                  if (_this2.fieldsValue[v] !== undefined) {
                    fieldsValue[v] = _this2.fieldsValue[v];
                  }
                });
              }
            },
            /**
             * 获取某个输入表单控件的值
             * @param  {string} name 表单空间name值
             * @return {object} 返回指定fieldValue
             */
            getFieldValue: function getFieldValue(name) {
              return _this2.fieldsValue[name];
            },
            /**
             * 重置一组输入控件的值（为 initialValue）与状态，如不传入参数，则重置所有组件
             * @param {array} 表单names，即各个表单组件的name数组
             */
            resetFields: function resetFields(names) {
              _this2.trigger('form-reset-field-value', names);
            },
            /**
             * 设置一组输入控件的值
             * @param {object} fieldsValue 格式为{fieldName1: value1,fieldName2: value2}
             */
            setFieldsValue: function setFieldsValue(fieldsValue) {
              for (var k in fieldsValue) {
                _this2.trigger('form-set-field-value-' + k, fieldsValue[k]);
              }
            },
            /**
             * 校验并获取一组输入域的值与 Error，若 fieldNames 参数为空，则校验全部组件
             * @param {array} 表单names，即各个表单组件的name数组，如果传入函数则变成callback参数
             * @param {function} callback function(err,fieldsValue){}
             */
            validateFields: function validateFields(names, callback) {
              var fieldsValidate = {};
              if (isFunction(names)) {
                //如果name是函数则变成callback
                callback = names;
                fieldsValidate = _this2.fieldsValidate;
              } else if (names && names[0]) {
                names.forEach(function (v) {
                  fieldsValidate[v] = _this2.fieldsValidate[v];
                });
              } else {
                fieldsValidate = _this2.fieldsValidate;
              }
              var fieldsValidateArray = [];
              for (var k in fieldsValidate) {
                if (fieldsValidate[k]) {
                  fieldsValidateArray.push(fieldsValidate[k]());
                } else {
                  console.warn('\u8868\u5355\u63A7\u4EF6' + k + ' \u9A8C\u8BC1\u4E0D\u5B58\u5728');
                }
              }
              _Promise.all(fieldsValidateArray).then(function (errors) {
                var fieldsError = void 0;
                errors.forEach(function (v, isArrayInput) {
                  if (v && v[0] && v[0].field) {
                    if (!fieldsError) {
                      fieldsError = {};
                    }
                    if (isArrayInput) {
                      var arrayItemName = v[0].field.split('_-_')[0];
                      if (!fieldsError[arrayItemName]) {
                        fieldsError[arrayItemName] = [];
                      }
                      fieldsError[arrayItemName].push(v);
                    } else {
                      fieldsError[v[0].field] = v;
                    }
                  }
                });
                return fieldsError;
              }).then(function (errors) {
                callback && callback(errors, !!errors ? undefined : _this2.fieldsValue);
              });
            }
          }, _this2.fieldsValidate = {}, _this2.fieldsValue = {}, _this2.tempFieldsValue = {}, _this2.fieldsError = {}, _this2.tempFieldsError = {}, _temp2), _possibleConstructorReturn(_this2, _ret);
        }

        _createClass(Decorator, [{
          key: 'getChildContext',
          value: function getChildContext() {
            return {
              form: this.form,
              //通过context传递给子组件使用，目前basic-component在使用
              //表单验证都是在这里处理的
              FormItem: this.formItem,
              on: this.on.bind(this),
              //由于form的trigger覆盖了，所以使用了triggerEvent
              triggerEvent: this.trigger.bind(this)
            };
          }
          //存放各个filed的验证方法

          //临时存放fieldsValue

          //临时存放fieldsError

        }, {
          key: 'componentWillMount',

          //v17.0版本后会移除componentWillMount
          value: function componentWillMount() {
            var _this5 = this;

            this.on('form-values', function (_ref3) {
              var name = _ref3.name,
                  fieldValue = _ref3.fieldValue,
                  isArrayInput = _ref3.isArrayInput,
                  arrayItemIndexs = _ref3.arrayItemIndexs;

              if (!isArrayInput) {
                if (fieldValue) {
                  _this5.fieldsValue[name] = fieldValue;
                } else {
                  delete _this5.fieldsValue[name];
                }
              } else {
                //专门处理array-input value值
                if (fieldValue) {
                  _this5.tempFieldsValue[name] = fieldValue;
                } else {
                  delete _this5.tempFieldsValue[name];
                }
                var arrayItemName = name.split('_-_')[0];
                _this5.setFieldByType('fieldsValue', arrayItemName, arrayItemIndexs);
              }
            });
            this.on('form-errors', function (_ref4) {
              var name = _ref4.name,
                  fieldError = _ref4.fieldError,
                  isArrayInput = _ref4.isArrayInput,
                  arrayItemIndexs = _ref4.arrayItemIndexs;

              if (!isArrayInput) {
                if (fieldError) {
                  _this5.fieldsError[name] = fieldError;
                } else {
                  delete _this5.fieldsError[name];
                }
              } else {
                //专门处理array-input error值
                if (fieldError) {
                  _this5.tempFieldsError[name] = fieldError;
                } else {
                  delete _this5.tempFieldsError[name];
                }
                var arrayItemName = name.split('_-_')[0];
                _this5.setFieldByType('fieldsError', arrayItemName, arrayItemIndexs);
              }
            });

            this.on('array-item-index-change', function (_ref5) {
              var name = _ref5.name,
                  arrayItemIndexs = _ref5.arrayItemIndexs;

              _this5.setFieldByType('fieldsValue', name, arrayItemIndexs);
              _this5.setFieldByType('fieldsError', name, arrayItemIndexs);
            });
          }
        }, {
          key: 'setFieldByType',
          value: function setFieldByType(fieldType, name, arrayItemIndexs) {
            var _this6 = this;

            var arrayItemName = name;
            this[fieldType][arrayItemName] = [];
            arrayItemIndexs.forEach(function (v, k) {
              _this6[fieldType][arrayItemName][k] = _this6['temp' + toUpperCaseByPosition(fieldType)][arrayItemName + '_-_' + v];
            });
            this[fieldType][arrayItemName] = this[fieldType][arrayItemName].filter(function (v) {
              return v;
            });
            if (this[fieldType][arrayItemName].length === 0) {
              delete this[fieldType][arrayItemName];
            }
          }
        }, {
          key: 'componentWillUnmount',
          value: function componentWillUnmount() {
            this.off();
          }
        }, {
          key: 'render',
          value: function render() {
            var WrapperComponent = this.getWrapperComponent();
            return React.createElement(WrapperComponent, _extends({}, this.props, { form: this.form }));
          }
        }]);

        return Decorator;
      }(React.Component), _class2.childContextTypes = {
        form: PropTypes.object,
        FormItem: PropTypes.func,
        on: PropTypes.func,
        //由于form的trigger覆盖了，所以使用了triggerEvent
        triggerEvent: PropTypes.func
      }, _temp3);
      //整合backbone全局事件处理方式

      _Object$assign(Decorator.prototype, event);
      return function (WrappedComponent) {
        function getDisplayName(WrappedComponent) {
          return WrappedComponent.displayName || WrappedComponent.name || 'WrappedComponent';
        }
        Decorator.displayName = 'Form(' + getDisplayName(WrappedComponent) + ')';
        Decorator.prototype.getWrapperComponent = function () {
          return WrappedComponent;
        };
        return Decorator;
      };
    }
  }]);

  return Form;
}(React.Component), _class.propTypes = {
  size: PropTypes.string,
  hasFeedback: PropTypes.bool,
  labelCol: PropTypes.object,
  wrapperCol: PropTypes.object,
  trigger: PropTypes.string,
  locale: PropTypes.object
}, _class.contextTypes = {
  antLocale: PropTypes.object
}, _class.childContextTypes = {
  size: PropTypes.string,
  hasFeedback: PropTypes.bool,
  labelCol: PropTypes.object,
  wrapperCol: PropTypes.object,
  trigger: PropTypes.string,
  locale: PropTypes.object,
  //是否使用了Form
  useForm: PropTypes.bool
}, _temp);

function getFormItemComponent(that) {
  var _class4, _temp6;

  return _temp6 = _class4 = function (_React$Component3) {
    _inherits(_class4, _React$Component3);

    function _class4() {
      var _ref6;

      var _temp5, _this7, _ret3;

      _classCallCheck(this, _class4);

      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      return _ret3 = (_temp5 = (_this7 = _possibleConstructorReturn(this, (_ref6 = _class4.__proto__ || _Object$getPrototypeOf(_class4)).call.apply(_ref6, [this].concat(args))), _this7), _this7.state = {
        value: _this7.props.initialValue,
        //有初始值则需要验证是否合法才给渲染，否则不用。
        canBeRendered: _this7.props.initialValue ? false : true
      }, _this7.name = _this7.props.name, _this7.onChangeOrBlurEvent = function (e, shouldValidate) {
        var _this7$props = _this7.props,
            noFormItem = _this7$props.noFormItem,
            type = _this7$props.type;

        var value = void 0;
        if (!e) {
          value = undefined;
        } else if (e.target) {
          value = e.target.value;
        } else {
          value = e;
        }
        if (type === 'file') {
          //特殊处理type=file的情况
          value = e.target.files[0];
        }
        if (type === 'checkbox') {
          //特殊处理type=file的情况
          if (e.target.checked) {
            value = e.target.checked;
          } else {
            value = '';
          }
        }
        if (!noFormItem && shouldValidate) {
          _this7.validateField(_this7.name, value, _this7.props.rules);
        } else {
          _this7.setState({ value: value });
        }
      }, _this7.trigger = _this7.props.trigger || _this7.context.trigger || 'onChange', _this7.onBlur = function (e) {
        var trigger = _this7.trigger;
        if (trigger === 'onBlur') {
          _this7.onChangeOrBlurEvent(e, trigger === 'onBlur');
        }
        var onBlur = _this7.props.onBlur;

        onBlur && onBlur(e);
      }, _this7.onChange = function (e) {
        var trigger = _this7.trigger;
        _this7.onChangeOrBlurEvent(e, trigger === 'onChange');
        var onChange = _this7.props.onChange;

        onChange && onChange(e);
      }, _temp5), _possibleConstructorReturn(_this7, _ret3);
    }

    _createClass(_class4, [{
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        var name = this.name;
        that.off('form-set-field-value-' + name);
        //删除unmount组件的validate
        delete that.fieldsValidate[name];
        this.triggerFormValue(name);
        this.triggerFormError(name);
      }
    }, {
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _this8 = this;

        var name = this.name;
        var _props = this.props,
            initialValue = _props.initialValue,
            rules = _props.rules;

        if (initialValue) {
          //设置初始化默认值
          // that.fieldsValue[name] = initialValue;
          //验证默认值是否合法
          this.validateField(name, initialValue, rules);
        }
        if (!this.props.noFormItem) {
          that.fieldsValidate[name] = function () {
            var value = _this8.state.value;

            return _this8.validateField(_this8.name, value, rules);
          };
        }
        that.on('form-set-field-value-' + name, function (value) {
          _this8.validateField(_this8.name, value, rules);
        });
        that.on('form-reset-field-value', function (names) {
          var resetValue = function resetValue() {
            if (initialValue) {
              _this8.validateField(name, initialValue, rules);
            } else {
              _this8.setState({
                value: initialValue,
                errors: undefined,
                validateStatus: undefined
              });
            }
            _this8.triggerFormValue(name, initialValue);
            _this8.triggerFormError(name);
          };
          if (names && names[0]) {
            if (!!~names.indexOf(name)) {
              //names存在值一致的${name}则重置
              resetValue();
            }
          } else if (!names) {
            resetValue();
          }
        });
      }
    }, {
      key: 'triggerFormValue',
      value: function triggerFormValue(name, value) {
        that.trigger('form-values', {
          name: name,
          fieldValue: value,
          isArrayInput: this.context.isArrayInput,
          arrayItemIndexs: this.props.arrayItemIndexs
        });
      }
    }, {
      key: 'triggerFormError',
      value: function triggerFormError(name, error) {
        that.trigger('form-errors', {
          name: name,
          fieldError: error,
          isArrayInput: this.context.isArrayInput,
          arrayItemIndexs: this.props.arrayItemIndexs
        });
      }
    }, {
      key: 'validateField',
      value: function validateField(name, value, rules) {
        var _this9 = this;

        return new _Promise(function (resolve) {
          _validateField(name, value, rules)(function () {
            _this9.setState({
              value: value,
              errors: undefined,
              validateStatus: 'success',
              canBeRendered: true
            });
            _this9.triggerFormValue(name, value);
            _this9.triggerFormError(name);
            resolve();
          }, function (errors) {
            _this9.setState({
              value: value,
              errors: errors,
              validateStatus: 'error',
              canBeRendered: true
            });
            _this9.triggerFormValue(name);
            _this9.triggerFormError(name, errors);
            resolve(errors, _this9.context.isArrayInput);
          });
        });
      }
    }, {
      key: 'getErrorMessage',
      value: function getErrorMessage() {
        if (!this.props.noFormItem) {
          var errors = this.state.errors;

          var message = '';
          errors && errors.forEach(function (v, k) {
            if (k !== 0) {
              message += ',' + v.message;
            } else {
              message += v.message;
            }
          });
          return message;
        }
      }
      //渲染表单组件

    }, {
      key: 'renderItem',
      value: function renderItem(otherItemProps) {
        var context = this.context;
        this.deleteUnuseProps(otherItemProps);
        if (context.isAntdComponentDeep) {
          //这里目前只有array-input使用到
          return this.renderDeepItem(otherItemProps);
        } else {
          var children = otherItemProps.children,
              other = _objectWithoutProperties(otherItemProps, ['children']);

          return React.cloneElement(children, _extends({
            size: context.size
          }, other, {
            onChange: this.onChange,
            onBlur: this.onBlur,
            id: 'afc-form-item-' + this.name
          }));
        }
      }
      //渲染表单组件(children不是antd表单组件，在children.prop.chidren或者更深层)

    }, {
      key: 'renderDeepItem',
      value: function renderDeepItem(otherItemProps) {
        var _this10 = this;

        var context = this.context;

        var children = otherItemProps.children,
            other = _objectWithoutProperties(otherItemProps, ['children']);

        if (!children) {
          return false;
        }
        if (!children[0]) {
          //findAllReactComponentsByType，需要的数组，需要转换
          //后续需要转换回来。
          children = [children];
        }
        //这里会复杂一点，因为children不一定是antd表单组件，只是包含在更深层
        //所以需要找出来，然后把props传递过去（需要替换）。
        var targetItem = findAllReactComponentsByType(children, 'OriginalAntdComponent');
        if (targetItem.length > 1) {
          console.error('原生的Form.Item只能包含一个原生的antd组件');
        }
        targetItem.forEach(function (target) {
          var clone = React.cloneElement(target.child, _extends({
            size: context.size
          }, other, {
            onChange: _this10.onChange,
            onBlur: _this10.onBlur,
            id: 'afc-form-item-' + _this10.name
          }));
          //替换成最终的组件
          target.children[target.index] = clone;
        });
        //上面转换成数组后需要转换原来非数组children，否则会报key值不存在
        return children[0];
      }
    }, {
      key: 'deleteUnuseProps',
      value: function deleteUnuseProps(otherItemProps) {
        delete otherItemProps.onlyLetter;
        delete otherItemProps.min;
        delete otherItemProps.max;
        delete otherItemProps.initialValue;
        delete otherItemProps.rules;
        delete otherItemProps.trigger;
        delete otherItemProps.aliasLabel;
        delete otherItemProps.arrayItemIndexs;
      }
    }, {
      key: 'render',
      value: function render() {
        var _state = this.state,
            validateStatus = _state.validateStatus,
            canBeRendered = _state.canBeRendered;

        if (!canBeRendered) {
          return false;
        }
        var errorMessage = this.getErrorMessage();
        var context = this.context;

        var _props2 = this.props,
            required = _props2.required,
            label = _props2.label,
            noFormItem = _props2.noFormItem,
            otherItemProps = _objectWithoutProperties(_props2, ['required', 'label', 'noFormItem']);

        if (otherItemProps.type !== 'file') {
          //input type=file是不受控表单
          otherItemProps.value = this.state.value;
        }
        var hasFeedback = context.hasFeedback;
        if (this.trigger === 'onBlur') {
          //onBlur时，feedback用户体验不好，直接禁止
          hasFeedback = false;
        } else if (otherItemProps.type === 'radio-group' || otherItemProps.type === 'checkbox' || otherItemProps.type === 'checkbox-group') {
          //checkbox不需要feedback提示，影响布局美观
          hasFeedback = false;
        }
        if (noFormItem || otherItemProps.type === 'hidden' || context.isGroup) {
          return this.renderItem(otherItemProps);
        } else {
          return React.createElement(
            AForm.Item,
            _extends({
              hasFeedback: hasFeedback,
              wrapperCol: context.wrapperCol,
              labelCol: context.labelCol
            }, context.formItemProps, {
              help: errorMessage,
              validateStatus: validateStatus,
              label: label,
              required: required
            }),
            this.renderItem(otherItemProps)
          );
        }
      }
    }]);

    return _class4;
  }(React.Component), _class4.contextTypes = {
    size: PropTypes.string,
    hasFeedback: PropTypes.bool,
    labelCol: PropTypes.object,
    wrapperCol: PropTypes.object,
    formItemProps: PropTypes.object,
    trigger: PropTypes.string,
    //是否是group组件，如InputGroup，目前只有这个InputGroup传递了这个参数
    isGroup: PropTypes.bool,
    //是否是多层jsx包裹
    isAntdComponentDeep: PropTypes.bool,
    //是否是arrayInput
    isArrayInput: PropTypes.bool
  }, _temp6;
}
Form.Item = (_temp7 = _class5 = function (_React$Component4) {
  _inherits(FormItem, _React$Component4);

  function FormItem() {
    _classCallCheck(this, FormItem);

    return _possibleConstructorReturn(this, (FormItem.__proto__ || _Object$getPrototypeOf(FormItem)).apply(this, arguments));
  }

  _createClass(FormItem, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        formItemProps: this.props
      };
    }
    //Form.Item只是为了传递props到antd的Form.Item
    //如果没用到Form.Item的props，可以不使用。

  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);

  return FormItem;
}(React.Component), _class5.childContextTypes = {
  formItemProps: PropTypes.object
}, _temp7);

export default Form;