import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';

var _class, _temp;

//外部依赖包
import React from 'react';
// import AInput from 'antd/lib/input';
import classnames from 'classnames';
import PropTypes from 'prop-types';
import AInput from 'antd/lib/input';
import Radio from 'antd/lib/radio';
import Icon from 'antd/lib/icon';
import Button from 'antd/lib/button';
import isArray from 'lodash/isArray';
//内部依赖包
import { randomKey, swapArrayItem } from '../../utils/util';
import Form from '../form';
import Input from './index';

var RadioButton = Radio.Button;
var RadioGroup = Radio.Group;

AInput.displayName = 'OriginalAntdComponent';

var MultipleInput = (_temp = _class = function (_Input) {
  _inherits(MultipleInput, _Input);

  function MultipleInput(props) {
    _classCallCheck(this, MultipleInput);

    var _this = _possibleConstructorReturn(this, (MultipleInput.__proto__ || _Object$getPrototypeOf(MultipleInput)).call(this, props));

    _this.componentType = 'multiple-input';

    _this.onRadioChange = function (index) {
      return function (e) {
        var triggerEvent = _this.context.triggerEvent;

        var data = _this.itemKeys;
        switch (e.target.value) {
          case 'up':
            swapArrayItem(data, index, index - 1);
            triggerEvent('array-item-index-change', {
              name: _this.props.name,
              arrayItemIndexs: data
            });
            break;
          case 'down':
            swapArrayItem(data, index, index + 1);
            triggerEvent('array-item-index-change', {
              name: _this.props.name,
              arrayItemIndexs: data
            });
            break;
          case 'delete':
            data.splice(index, 1);
            break;
          default:
        }

        _this.setState({});
      };
    };

    _this.onPlusClickEvent = function (e) {
      _this.itemKeys.push(randomKey());
      _this.setState({});
    };

    _this.itemKeys = [];
    var value = _this.props.value;

    if (!isArray(value)) {
      value = [value];
    }
    value.forEach(function (v) {
      _this.itemKeys.push(randomKey());
    });
    return _this;
  }

  _createClass(MultipleInput, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isAntdComponentDeep: true,
        isArrayInput: true
      };
    }
  }, {
    key: 'getUpDisabled',
    value: function getUpDisabled(index) {
      if (this.itemKeys.length === 1) {
        return true;
      }
      if (index === 0) {
        return true;
      }
    }
  }, {
    key: 'getDownDisabled',
    value: function getDownDisabled(index) {
      if (this.itemKeys.length === 1) {
        return true;
      }
      if (index === this.itemKeys.length - 1) {
        return true;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          _props$value = _props.value,
          value = _props$value === undefined ? [] : _props$value,
          other = _objectWithoutProperties(_props, ['value']);

      var size = this.context.size || 'default';
      return React.createElement(
        'div',
        {
          className: classnames('afc-array-item clearfix', {
            'afc-array-item-small': size === 'small',
            'afc-array-item-default': size === 'default',
            'afc-array-item-large': size === 'large'
          })
        },
        this.itemKeys.map(function (v, k) {
          if (k !== 0) {
            other.label = 'null';
          }
          if (value[k] === undefined) {
            //因为下面需要转换成字符串了
            value[k] = '';
          }
          var hideLabel = other.label === 'null' ? true : false;
          return React.createElement(
            Form.Item,
            {
              className: classnames({ 'afc-hide-label': hideLabel }),
              key: v
            },
            _this2.renderFormItem(React.createElement(
              'div',
              { className: 'afc-array-item-con' },
              React.createElement(
                'div',
                { className: 'afc-array-item-left' },
                React.createElement(AInput, null)
              ),
              React.createElement(
                'div',
                { className: 'afc-array-item-right' },
                React.createElement(
                  RadioGroup,
                  {
                    className: 'afc-array-item-radiogroup',
                    onChange: _this2.onRadioChange(k),
                    value: '',
                    size: size
                  },
                  React.createElement(
                    RadioButton,
                    { value: 'up', disabled: _this2.getUpDisabled(k) },
                    React.createElement(Icon, { type: 'arrow-up' })
                  ),
                  React.createElement(
                    RadioButton,
                    {
                      value: 'down',
                      disabled: _this2.getDownDisabled(k)
                    },
                    React.createElement(Icon, { type: 'arrow-down' })
                  ),
                  React.createElement(
                    RadioButton,
                    {
                      value: 'delete',
                      disabled: _this2.itemKeys.length === 1
                    },
                    React.createElement(Icon, { type: 'delete' })
                  )
                )
              )
            ), {
              label: other.label,
              //_-_这个特殊符号是为了防止可能存在的重复name
              //同时用来提取前面的name值
              name: other.name + '_-_' + v,
              arrayItemIndexs: _this2.itemKeys,
              //如果是数字转换成字符串
              //input表单值不存在值为数字的情况。
              initialValue: isArray(value) ? value[k] + '' : value + ''
            })
          );
        }),
        React.createElement(
          Button,
          {
            type: 'primary',
            className: 'afc-array-item-plus',
            onClick: this.onPlusClickEvent
          },
          React.createElement(Icon, { type: 'plus' })
        )
      );
    }
  }]);

  return MultipleInput;
}(Input), _class.childContextTypes = {
  //是否是多层jsx包裹
  isAntdComponentDeep: PropTypes.bool,
  isArrayInput: PropTypes.bool
}, _temp);
export { MultipleInput as default };