import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _extends from 'babel-runtime/helpers/extends';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _get from 'babel-runtime/helpers/get';
import _inherits from 'babel-runtime/helpers/inherits';

var _class4, _temp5;

//外部依赖包
import React from 'react';
import PropTypes from 'prop-types';
import AInput from 'antd/lib/input';
import AForm from 'antd/lib/form';
//内部依赖包
import BasicComponent from '../basic-component';

AInput.displayName = 'OriginalAntdComponent';

var Input = function (_BasicComponent) {
  _inherits(Input, _BasicComponent);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || _Object$getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.currentAntdComponent = AInput, _this.localeKey = 'afcInput', _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Input, [{
    key: 'getSepcialRuleByType',
    value: function getSepcialRuleByType(type) {
      //继承父类可能有的rules
      var rules = _get(Input.prototype.__proto__ || _Object$getPrototypeOf(Input.prototype), 'getSepcialRuleByType', this).call(this);
      var locale = this.locale;
      switch (type) {
        case 'email':
          rules.push({
            type: 'email',
            message: locale.afcInput.emailFormat
          });
          break;
        case 'url':
          rules.push({
            type: 'url',
            message: locale.afcInput.urlFormat
          });
          break;
        default:
      }
      return rules;
    }
  }]);

  return Input;
}(BasicComponent);

export { Input as default };

Input.TextArea = function (_BasicComponent2) {
  _inherits(InputTextArea, _BasicComponent2);

  function InputTextArea() {
    var _ref2;

    var _temp2, _this2, _ret2;

    _classCallCheck(this, InputTextArea);

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret2 = (_temp2 = (_this2 = _possibleConstructorReturn(this, (_ref2 = InputTextArea.__proto__ || _Object$getPrototypeOf(InputTextArea)).call.apply(_ref2, [this].concat(args))), _this2), _this2.currentAntdComponent = AInput.TextArea, _temp2), _possibleConstructorReturn(_this2, _ret2);
  }

  return InputTextArea;
}(BasicComponent);
Input.Search = function (_BasicComponent3) {
  _inherits(InputSearch, _BasicComponent3);

  function InputSearch() {
    var _ref3;

    var _temp3, _this3, _ret3;

    _classCallCheck(this, InputSearch);

    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return _ret3 = (_temp3 = (_this3 = _possibleConstructorReturn(this, (_ref3 = InputSearch.__proto__ || _Object$getPrototypeOf(InputSearch)).call.apply(_ref3, [this].concat(args))), _this3), _this3.currentAntdComponent = AInput.Search, _temp3), _possibleConstructorReturn(_this3, _ret3);
  }

  return InputSearch;
}(BasicComponent);
Input.Group = (_temp5 = _class4 = function (_React$Component) {
  _inherits(InputGroup, _React$Component);

  function InputGroup() {
    var _ref4;

    var _temp4, _this4, _ret4;

    _classCallCheck(this, InputGroup);

    for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    return _ret4 = (_temp4 = (_this4 = _possibleConstructorReturn(this, (_ref4 = InputGroup.__proto__ || _Object$getPrototypeOf(InputGroup)).call.apply(_ref4, [this].concat(args))), _this4), _this4.state = {}, _temp4), _possibleConstructorReturn(_this4, _ret4);
  }

  _createClass(InputGroup, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        isGroup: true
      };
    }
  }, {
    key: 'getChildrenNames',

    //验证是否是AntdFormComponent组件
    //所有AntdFormComponent都打上了标记
    value: function getChildrenNames() {
      var children = this.props.children;

      if (!children) {
        return;
      }
      if (children && !children[0]) {
        children = [children];
      }
      var names = [];
      children.forEach(function (v, k) {
        if (v.type.displayName !== 'AntdFormComponent') {
          console.error('InputGroup\u7684\u7B2C' + (k + 1) + '\u4E2A\u5B50\u7EC4\u4EF6\u4E0D\u662Fantd-form-component\u7EC4\u4EF6!');
        }
        if (v.props.name) {
          names.push(v.props.name);
        }
      });
      return names;
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this5 = this;

      var names = this.getChildrenNames();
      this.context.on && this.context.on('form-errors', function (_ref5) {
        var name = _ref5.name,
            fieldError = _ref5.fieldError;

        if (!!~names.indexOf(name)) {
          //只处理input-group里表单组件的错误
          _this5.setState({
            fieldsError: _extends({}, _this5.state.fieldsError, _defineProperty({}, name, fieldError))
          });
        }
      });
    }
  }, {
    key: 'getErrorMessage',
    value: function getErrorMessage() {
      var fieldsError = this.state.fieldsError;

      if (!fieldsError) {
        return;
      }
      var messageArray = [];
      var message = '';
      for (var k in fieldsError) {
        if (fieldsError[k]) {
          //eslint-disable-next-line
          fieldsError[k].forEach(function (v) {
            messageArray.push(v.message);
          });
        }
      }
      messageArray.forEach(function (m, k) {
        if (k !== 0) {
          message += ',' + m;
        } else {
          message += m;
        }
      });
      return message;
    }
  }, {
    key: 'getValidateStatus',
    value: function getValidateStatus(errorMessage) {
      if (errorMessage) {
        return errorMessage ? 'error' : 'success';
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          label = _props.label,
          noFormItem = _props.noFormItem,
          other = _objectWithoutProperties(_props, ['label', 'noFormItem']);

      var errorMessage = this.getErrorMessage();
      var context = this.context;
      if (noFormItem) {
        return React.createElement(AInput.Group, other);
      } else {
        return React.createElement(
          AForm.Item,
          _extends({
            className: 'afc-input-group',
            hasFeedback: context.hasFeedback,
            wrapperCol: context.wrapperCol,
            labelCol: context.labelCol
          }, context.formItemProps, {
            label: label,
            help: errorMessage,
            validateStatus: this.getValidateStatus(errorMessage)
          }),
          React.createElement(AInput.Group, other)
        );
      }
    }
  }]);

  return InputGroup;
}(React.Component), _class4.contextTypes = {
  formItemProps: PropTypes.object,
  form: PropTypes.object,
  on: PropTypes.func,
  hasFeedback: PropTypes.bool,
  labelCol: PropTypes.object,
  wrapperCol: PropTypes.object
}, _class4.childContextTypes = {
  isGroup: PropTypes.bool
}, _temp5);