import _extends from 'babel-runtime/helpers/extends';
import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import _objectWithoutProperties from 'babel-runtime/helpers/objectWithoutProperties';
import _Object$getPrototypeOf from 'babel-runtime/core-js/object/get-prototype-of';
import _classCallCheck from 'babel-runtime/helpers/classCallCheck';
import _createClass from 'babel-runtime/helpers/createClass';
import _possibleConstructorReturn from 'babel-runtime/helpers/possibleConstructorReturn';
import _inherits from 'babel-runtime/helpers/inherits';
//外部依赖包
import React from 'react';
// import PropTypes from 'prop-types';
//内部依赖包
import BasicComponent from '../basic-component';
import Input from '../input';

var Password = function (_BasicComponent) {
  _inherits(Password, _BasicComponent);

  function Password() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Password);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Password.__proto__ || _Object$getPrototypeOf(Password)).call.apply(_ref, [this].concat(args))), _this), _this.localeKey = 'afcPassword', _this.state = { passwordValue: '' }, _this.onPasswordChange = function (e) {
      var onChange = _this.props.onChange;

      _this.setState({
        passwordValue: e.target.value
      });
      onChange && onChange(e);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Password, [{
    key: 'getChekckPasswordRule',
    value: function getChekckPasswordRule() {
      var _this2 = this;

      var locale = this.locale;
      var rules = [{
        validator: function validator(rule, value, callback) {
          var passwordValue = _this2.state.passwordValue;
          var errors = [];
          if (passwordValue !== value) {
            errors.push({
              message: locale.afcPassword.checkErrorMsg
            });
          }
          callback(errors);
        }
      }];
      return rules;
    }
  }, {
    key: 'getOnlyLetterAndNumberRule',
    value: function getOnlyLetterAndNumberRule() {
      var locale = this.locale;
      return [{
        validator: function validator(rule, value, callback, source, options) {
          var errors = [];
          //数组和字母结合
          var pass = new RegExp('^(?![0-9]+$)(?![a-zA-Z]+$)[0-9A-Za-z]*$').test(value);
          if (!pass && value !== '') {
            errors.push({
              message: locale.afcPassword.formatErrorMsg
            });
          }
          callback(errors);
        }
      }];
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          rePassword = _props.rePassword,
          _props$type = _props.type,
          type = _props$type === undefined ? 'password' : _props$type,
          checkPassword = _props.checkPassword,
          _props$rules = _props.rules,
          rules = _props$rules === undefined ? [] : _props$rules,
          other = _objectWithoutProperties(_props, ['rePassword', 'type', 'checkPassword', 'rules']);

      var locale = this.locale;
      return React.createElement(
        'span',
        null,
        React.createElement(Input, _extends({
          autoComplete: 'new-password',
          type: type
        }, other, {
          onChange: this.onPasswordChange,
          rules: [].concat(_toConsumableArray(rules), _toConsumableArray(this.getOnlyLetterAndNumberRule()))
        })),
        (rePassword || checkPassword) &&
        //rePassword视为了兼容之前的formBuilder的api
        React.createElement(Input, _extends({
          autoComplete: 'new-password',
          type: type
        }, other, {
          label: locale.afcPassword.checkLabel,
          name: 'check-' + other.name,
          rules: this.getChekckPasswordRule()
        }))
      );
    }
  }]);

  return Password;
}(BasicComponent);

export { Password as default };