'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2, _temp2; //外部依赖包


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

var _defaultRules = require('../decorator/defaultRules');

var _defaultRules2 = _interopRequireDefault(_defaultRules);

var _validate = require('../decorator/validate');

var _validate2 = _interopRequireDefault(_validate);

var _commonContext = require('../decorator/commonContext');

var _commonContext2 = _interopRequireDefault(_commonContext);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 如果覆盖了render则，用不到componentType、currentAntdComponent、getSepcialRuleByType、getDefaultRules
 */

// import pureRenderWithLodashDecorator from '../decorator/pureRenderWithLodash';

//防止被重复渲染
// @pureRenderWithLodashDecorator
//验证name等值是否定义
var BasicComponent = (0, _validate2.default)(_class = (0, _defaultRules2.default)(_class = (0, _commonContext2.default)(_class = (_temp2 = _class2 = function (_React$Component) {
  (0, _inherits3.default)(BasicComponent, _React$Component);

  function BasicComponent() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, BasicComponent);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = BasicComponent.__proto__ || (0, _getPrototypeOf2.default)(BasicComponent)).call.apply(_ref, [this].concat(args))), _this), _this.componentType = 'text', _this.currentAntdComponent = undefined, _this.localeKey = undefined, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }
  //这里把所有基础表单组件的propTypes都定义了

  //定义组件类型，如果组件props.type没有设置，则用组件默认设置的
  //继承此类，看情况覆盖这个属性

  //定义当前需要用到的antd表单组件

  //当前组件的locale对象，如input的是afcInput


  (0, _createClass3.default)(BasicComponent, [{
    key: 'getSepcialRuleByType',

    //设置特殊的async-validator rules
    value: function getSepcialRuleByType() {
      return [];
    }
  }, {
    key: 'renderFormItem',
    value: function renderFormItem(item, otherProps) {
      var FormItem = this.context.FormItem;
      var _props = this.props,
          name = _props.name,
          value = _props.value,
          _props$rules = _props.rules,
          rules = _props$rules === undefined ? [] : _props$rules,
          other = (0, _objectWithoutProperties3.default)(_props, ['name', 'value', 'rules']);

      var specialRules = this.getSepcialRuleByType(other.type);
      if (other.type === 'email' || other.type === 'url') {
        other.type = 'text';
      }
      if (!other.type && this.componentType) {
        //处理checkbox等
        other.type = this.componentType;
      }
      return _react2.default.createElement(
        FormItem,
        (0, _extends3.default)({}, other, {
          name: name,
          initialValue: value,
          rules: [].concat((0, _toConsumableArray3.default)(this.getDefaultRules(other.type, this.locale, other.label ? other.label : name)), (0, _toConsumableArray3.default)(specialRules), (0, _toConsumableArray3.default)(rules))
        }, otherProps),
        item
      );
    }
  }, {
    key: 'validateRender',
    value: function validateRender(component) {
      if (!this.currentAntdComponent) {
        console.error('继承BasicComponent，必须定义currentAntdComponent');
      }
      //如果没有使用Form.create()
      if (!this.context.form) {
        return component;
      }
      return this.renderFormItem(component);
    }
  }, {
    key: 'render',
    value: function render() {
      var component = _react2.default.createElement(
        this.currentAntdComponent,
        null,
        this.props.children
      );
      return this.validateRender(component);
    }
  }, {
    key: 'locale',
    get: function get() {
      if (!this._tempLocale) {
        var currentComponentLocale = {};
        if (this.localeKey) {
          currentComponentLocale = (0, _defineProperty3.default)({}, this.localeKey, this.props.locale || {});
        }
        //context.locale是getter
        this._tempLocale = (0, _merge2.default)(this.context.locale || {}, currentComponentLocale);
      }
      return this._tempLocale;
    }
  }]);
  return BasicComponent;
}(_react2.default.Component), _class2.displayName = 'AntdFormComponent', _class2.propTypes = {
  name: _propTypes2.default.string,
  label: _propTypes2.default.string,
  type: _propTypes2.default.string,
  rules: _propTypes2.default.array,
  //input
  min: _propTypes2.default.number,
  //input
  max: _propTypes2.default.number,
  //input
  onlyLetter: _propTypes2.default.bool,
  //password（passord继承input）
  onlyLetterAndNumber: _propTypes2.default.bool,
  //password
  checkPassword: _propTypes2.default.bool
}, _temp2)) || _class) || _class) || _class;

exports.default = BasicComponent;